macroscript LP_Auto_Gamma category:"LastPixel" buttontext:"LP_Auto_Gamma" 
(

	global AutoGammaCC_ScriptedUI
	global AutoGammaCC_Controls
	global AutoGammaCC_OverrideRollout

	rollout AutoGammaCC_Controls "Controls" width:354 height:105
	(
		radiobuttons rdoCurrentState "Current state:" pos:[7,9] width:185 height:62 labels:#("On", "Off - remove CC maps on next render", "Leave scene as is currently")
		button btnManualApply "Apply CCs now" pos:[232,26] width:97 height:18
		button btnManualRemove "Remove CCs now" pos:[232,49] width:97 height:18
		GroupBox grp14 "Manual control" pos:[212,8] width:135 height:65
		checkbox chkRemoveCCsAfterRender "Remove CCs after each render" pos:[8,80] width:169 height:17
		label lbl54 "Current Gamma Value:" pos:[196,81] width:109 height:18
		label lblCurrentGamma "2.2" pos:[314,81] width:31 height:16
		
		fn refreshUI = (
			rdoCurrentState.state = AutoGammaEnabledState + 1
			chkRemoveCCsAfterRender.state = if (AutoGammaRemoveAfterRender==0) then false else true
			
			lblCurrentGamma.text = (getAutoGammaInternalCC()).gamma as string
		)
		
		on AutoGammaCC_Controls open do (
			refreshUI()			
		)
		
		on rdoCurrentState changed state do (
			AutoGammaEnabledState = state - 1
			
			if (AutoGammaEnabledState == 0) then (
				fileInGamma = fileOutGamma = 1.0
			)
		)
		
		on chkRemoveCCsAfterRender changed state do (
			AutoGammaRemoveAfterRender = if (state) then 1 else 0
		)
		
		on btnManualApply pressed do (
			forceAutoGammaCCs 0
		)

		on btnManualRemove pressed do (
			forceAutoGammaCCs 1
		)
	)
	
	rollout AutoGammaCC_OverrideRollout "Override Values" width:354 height:624
	(
		local internalCCMap
		
		GroupBox grp1 "RGB Space ( Pre-Process )" pos:[6,7] width:339 height:126
		label lbl1 "Brightness (%)" pos:[51,45] width:71 height:16
		label lbl2 "Contrast (%)" pos:[61,64] width:59 height:16
		label lbl3 "Gamma" pos:[81,83] width:39 height:16
		label lbl5 "Hue (deg)" pos:[69,176] width:49 height:16
		label lbl6 "Saturation (%)" pos:[52,195] width:68 height:16
		label lbl7 "Lightness (%)" pos:[55,214] width:65 height:16
		label lbl8 "Offset" pos:[138,157] width:36 height:15
		label lbl9 "Gain" pos:[215,157] width:36 height:15
		label lbl10 "Hue (deg)" pos:[69,284] width:49 height:16
		label lbl11 "Saturation (%)" pos:[52,303] width:68 height:16
		label lbl12 "Value (%)" pos:[55,322] width:65 height:16
		label lbl13 "Offset" pos:[138,265] width:36 height:15
		label lbl14 "Gain" pos:[215,265] width:36 height:15


		checkbox chkRGBOn "ON" pos:[16,27] width:35 height:16
		spinner spnBrightness "" pos:[122,45] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnContrast "" pos:[122,64] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnGamma "" pos:[122,83] width:60 height:16 range:[0.01,10,0]
		checkbox chkMono "Mono" pos:[207,45] width:69 height:16
		checkbox chkInvert "Invert" pos:[207,64] width:69 height:16
		checkbox chkUnmultiplyAlpha "Un-multiply Alpha" pos:[207,83] width:106 height:16
		checkbox chkClampOn "Clamp" pos:[47,103] width:50 height:16
		spinner spnClampMin "" pos:[104,103] width:57 height:16 range:[-1e+007,999999,0]
		spinner spnClampMax "" pos:[163,103] width:57 height:16 range:[-1e+007,999999,0]
		checkbox chkNormalize "Normalize" pos:[237,103] width:73 height:16

		GroupBox grp3 "HSL Space" pos:[6,138] width:339 height:104
		checkbox chkHSLOn "ON" pos:[16,158] width:35 height:16
		spinner spnHSLHueOffset "" pos:[128,176] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSLHueGain "" pos:[205,176] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSLSaturationOffset "" pos:[128,195] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSLSaturationGain "" pos:[205,195] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSLLightnessOffset "" pos:[128,214] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSLLightnessGain "" pos:[205,214] width:60 height:16 range:[-1e+007,999999,0]

		GroupBox grp4 "HSV Space" pos:[6,246] width:339 height:104
		checkbox chkHSVOn "ON" pos:[16,266] width:35 height:16
		spinner spnHSVHueOffset "" pos:[128,284] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSVHueGain "" pos:[205,284] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSVSaturationOffset "" pos:[128,303] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSVSaturationGain "" pos:[205,303] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSVValueOffset "" pos:[128,322] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnHSVVaueGain "" pos:[205,322] width:60 height:16 range:[-1e+007,999999,0]
		
		GroupBox grp34 "RGBA Space Channel Mapping" pos:[6,356] width:339 height:157
		label lbl134 "R=" pos:[17,399] width:17 height:16
		label lbl135 "G=" pos:[17,421] width:17 height:16
		label lbl146 "B=" pos:[17,444] width:16 height:16
		label lbl19 "A=" pos:[17,466] width:16 height:16
		label lbl147 "Offset" pos:[168,376] width:36 height:15
		label lbl18 "Gain" pos:[244,376] width:36 height:15
		checkbox chkRGBAOn "ON" pos:[16,376] width:35 height:16
		dropDownList ddlR "" pos:[43,397] width:93 height:21 items:#("Red","Green", "Blue","Alpha","Intens","In Red","In Green","In Blue","In Alpha", "In Intens","HSL Hue","HSL Sat","HSL Lum","HSV Hue","HSV Sat","HSV Val")
		spinner spnROff "" pos:[155,399] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnRGain "" pos:[232,399] width:60 height:16 range:[-1e+007,999999,0]
		dropDownList ddlG "" pos:[43,419] width:93 height:21 items:#("Red","Green", "Blue","Alpha","Intens","In Red","In Green","In Blue","In Alpha", "In Intens","HSL Hue","HSL Sat","HSL Lum","HSV Hue","HSV Sat","HSV Val")
		spinner spnGOff "" pos:[155,421] width:60 height:16 range:[-1e+0107,999999,0]
		spinner spnGGain "" pos:[232,421] width:60 height:16 range:[-1e+007,999999,0]
		dropDownList ddlB "" pos:[43,442] width:93 height:21 items:#("Red","Green", "Blue","Alpha","Intens","In Red","In Green","In Blue","In Alpha", "In Intens","HSL Hue","HSL Sat","HSL Lum","HSV Hue","HSV Sat","HSV Val")
		spinner spnBOff "" pos:[155,444] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnBGain "" pos:[232,444] width:60 height:16 range:[-1e+007,999999,0]
		dropDownList ddlA "" pos:[43,464] width:93 height:21 items:#("Red","Green", "Blue","Alpha","Intens","In Red","In Green","In Blue","In Alpha", "In Intens","HSL Hue","HSL Sat","HSL Lum","HSV Hue","HSV Sat","HSV Val")
		spinner spnAOff "" pos:[155,466] width:60 height:16 range:[-1e+007,999999,0]
		spinner spnAGain "" pos:[232,466] width:60 height:16 range:[-1e+007,999999,0]
		checkbox chkPremultiplyNewAlpha "Pre-Multiply New Alpha" pos:[44,490] width:130 height:15

		GroupBox grp5 "RGB Space Post Process" pos:[6,517] width:339 height:72
		checkbox chkRGBPostOn "ON" pos:[16,537] width:35 height:16
		checkbox chkRGBPostMono "Mono" pos:[104,537] width:53 height:16
		checkbox chkRGBPostInvert "Invert" pos:[163,537] width:69 height:16
		checkbox chkRGBPostClamp "Clamp" pos:[44,561] width:50 height:16
		spinner spnRGBPostClampMin "" pos:[101,561] width:57 height:16 range:[-1e+007,999999,0]
		spinner spnRGBPostClampMax "" pos:[160,561] width:57 height:16 range:[-1e+007,999999,0]
		checkbox chkRGBPostNormalize "Normalize" pos:[234,561] width:73 height:16

		button btnResetSettings "Reset Settings" pos:[6,595] width:340 height:20	
		
		fn refreshUI = (
			internalCCMap = getAutoGammaInternalCC()
			
			chkRGBOn.state = internalCCMap.pre_on
			spnBrightness.value = internalCCMap.brightness
			spnContrast.value = internalCCMap.contrast
			spnGamma.value = internalCCMap.gamma
			chkUnmultiplyAlpha.state = internalCCMap.pre_unmultiply
			chkClampOn.state = internalCCMap.pre_clamp_on
			spnClampMin.value = internalCCMap.pre_clamp_min
			spnClampMax.value = internalCCMap.pre_clamp_max
			chkNormalize.state = internalCCMap.pre_clamp_norm
			chkInvert.state = internalCCMap.pre_invert
			chkMono.state = internalCCMap.pre_mono
			
			chkHSLOn.state = internalCCMap.hsl_on
			spnHSLHueOffset.value = internalCCMap.hsl_hue_off
			spnHSLHueGain.value = internalCCMap.hsl_hue_gain
			spnHSLSaturationOffset.value = internalCCMap.hsl_sat_off
			spnHSLSaturationGain.value = internalCCMap.hsl_sat_gain
			spnHSLLightnessOffset.value = internalCCMap.hsl_light_off
			spnHSLLightnessGain.value = internalCCMap.hsl_light_gain
			
			chkHSVOn.state = internalCCMap.hsv_on
			spnHSVHueOffset.value = internalCCMap.hsv_hue_off
			spnHSVHueGain.value = internalCCMap.hsv_hue_gain
			spnHSVSaturationOffset.value = internalCCMap.hsv_sat_off
			spnHSVSaturationGain.value = internalCCMap.hsv_sat_gain
			spnHSVValueOffset.value = internalCCMap.hsv_val_off
			spnHSVVaueGain.value = internalCCMap.hsv_val_gain
			
			chkRGBAOn.state = internalCCMap.rgba_on
			spnROff.value = internalCCMap.red_off
			spnRGain.value = internalCCMap.red_gain
			spnGOff.value = internalCCMap.green_off
			spnGGain.value = internalCCMap.green_gain
			spnBOff.value = internalCCMap.blue_off
			spnBGain.value = internalCCMap.blue_gain
			spnAOff.value = internalCCMap.alpha_off
			spnAGain.value = internalCCMap.alpha_gain
			ddlR.selection = internalCCMap.red_chan + 1
			ddlG.selection = internalCCMap.green_chan + 1
			ddlB.selection = internalCCMap.blue_chan + 1
			ddlA.selection = internalCCMap.alpha_chan + 1
			chkPremultiplyNewAlpha.state = internalCCMap.pre_multiply


			chkRGBPostOn.state = internalCCMap.post_on
			chkRGBPostClamp.state = internalCCMap.post_clamp_on
			spnRGBPostClampMin.value = internalCCMap.post_clamp_min
			spnRGBPostClampMax.value = internalCCMap.post_clamp_max
			chkRGBPostNormalize.state = internalCCMap.post_clamp_norm
			chkRGBPostInvert.state = internalCCMap.post_invert
			chkRGBPostMono.state = internalCCMap.post_mono
			
			AutoGammaCC_Controls.lblCurrentGamma.text = internalCCMap.gamma as string
		)
		
		on AutoGammaCC_OverrideRollout open do
		(
					refreshUI()
				)
		on AutoGammaCC_OverrideRollout rolledUp state do
		(
			refreshUI()
					if state then 
						AutoGammaCC_ScriptedUI.size.y = 780 else
						AutoGammaCC_ScriptedUI.size.y = 155	
				)
				
		on chkRGBOn changed state do internalCCMap.pre_on = state
		on spnBrightness changed state do internalCCMap.brightness = state
		on spnContrast changed state do internalCCMap.contrast = state
		on spnGamma changed state do (
			internalCCMap.gamma = state
			AutoGammaCC_Controls.lblCurrentGamma.text = internalCCMap.gamma as string
		)
		on chkUnmultiplyAlpha changed state do internalCCMap.pre_unmultiply = state
		on chkClampOn changed state do internalCCMap.pre_clamp_on = state
		on spnClampMin changed state do internalCCMap.pre_clamp_min = state
		on spnClampMax changed state do internalCCMap.pre_clamp_max = state
		on chkNormalize changed state do internalCCMap.pre_clamp_norm = state
		on chkInvert changed state do internalCCMap.pre_invert = state
		on chkMono changed state do internalCCMap.pre_mono = state
			
		on chkHSLOn changed state do internalCCMap.hsl_on = state
		on spnHSLHueOffset changed state do internalCCMap.hsl_hue_off = state
		on spnHSLHueGain changed state do internalCCMap.hsl_hue_gain = state
		on spnHSLSaturationOffset changed state do internalCCMap.hsl_sat_off = state
		on spnHSLSaturationGain changed state do internalCCMap.hsl_sat_gain = state
		on spnHSLLightnessOffset changed state do internalCCMap.hsl_light_off = state
		on spnHSLLightnessGain changed state do internalCCMap.hsl_light_gain = state
			
		on chkHSVOn changed state do internalCCMap.hsv_on = state
		on spnHSVHueOffset changed state do internalCCMap.hsv_hue_off = state
		on spnHSVHueGain changed state do internalCCMap.hsv_hue_gain = state
		on spnHSVSaturationOffset changed state do internalCCMap.hsv_sat_off = state
		on spnHSVSaturationGain changed state do internalCCMap.hsv_sat_gain = state
		on spnHSVValueOffset changed state do internalCCMap.hsv_val_off = state
		on spnHSVVaueGain changed state do internalCCMap.hsv_val_gain = state
			
		on chkRGBAOn changed state do internalCCMap.rgba_on = state
		on spnROff changed state do internalCCMap.red_off = state
		on spnRGain changed state do internalCCMap.red_gain = state
		on spnGOff changed state do internalCCMap.green_off = state
		on spnGGain changed state do internalCCMap.green_gain = state
		on spnBOff changed state do internalCCMap.blue_off = state
		on spnBGain changed state do internalCCMap.blue_gain = state
		on spnAOff changed state do internalCCMap.alpha_off = state
		on spnAGain changed state do internalCCMap.alpha_gain = state
		on ddlR selected state do internalCCMap.red_chan = state - 1
		on ddlG selected state do internalCCMap.green_chan = state - 1
		on ddlB selected state do internalCCMap.blue_chan = state - 1
		on ddlA selected state do internalCCMap.alpha_chan = state - 1
		on chkPremultiplyNewAlpha changed state do internalCCMap.pre_multiply = state
			
		on chkRGBPostOn changed state do internalCCMap.post_on = state
		on chkRGBPostClamp changed state do internalCCMap.post_clamp_on = state
		on spnRGBPostClampMin changed state do internalCCMap.post_clamp_min = state
		on spnRGBPostClampMax changed state do internalCCMap.post_clamp_max = state
		on chkRGBPostNormalize changed state do internalCCMap.post_clamp_norm = state
		on chkRGBPostInvert changed state do internalCCMap.post_invert = state
		on chkRGBPostMono changed state do internalCCMap.post_mono = state
			
		on btnResetSettings pressed do (
			internalCCMap.pre_on = true
			internalCCMap.brightness = 0
			internalCCMap.contrast = 100
			internalCCMap.gamma = 2.2
			internalCCMap.pre_unmultiply = false
			internalCCMap.pre_clamp_on = false 
			internalCCMap.pre_clamp_min = 0
			internalCCMap.pre_clamp_max = 1
			internalCCMap.pre_clamp_norm = false
			internalCCMap.pre_invert = false
			internalCCMap.pre_mono = false
			internalCCMap.hsl_on = false
			internalCCMap.hsl_hue_off = 0
			internalCCMap.hsl_hue_gain = 0
			internalCCMap.hsl_sat_off = 0
			internalCCMap.hsl_sat_gain = 100
			internalCCMap.hsl_light_off = 0
			internalCCMap.hsl_light_gain = 100
			internalCCMap.hsv_on = false
			internalCCMap.hsv_hue_off = 0
			internalCCMap.hsv_hue_gain = 0
			internalCCMap.hsv_sat_off = 0
			internalCCMap.hsv_sat_gain = 100
			internalCCMap.hsv_val_off = 0
			internalCCMap.hsv_val_gain = 100
			
			internalCCMap.rgba_on = false
			internalCCMap.red_off = 0
			internalCCMap.red_gain = 100
			internalCCMap.green_off = 0
			internalCCMap.green_gain = 100
			internalCCMap.blue_off = 0
			internalCCMap.blue_gain = 100
			internalCCMap.alpha_off = 0
			internalCCMap.alpha_gain = 100
			internalCCMap.red_chan = 0
			internalCCMap.green_chan = 1
			internalCCMap.blue_chan = 2
			internalCCMap.alpha_chan = 8
			internalCCMap.pre_multiply = false
			
			internalCCMap.post_on = false
			internalCCMap.post_clamp_on = false
			internalCCMap.post_clamp_min = 0
			internalCCMap.post_clamp_max = 1
			internalCCMap.post_clamp_norm = false
			internalCCMap.post_invert = false
			internalCCMap.post_mono = false
			
			refreshUI()
		)
		
	)
	


	try (closeRolloutFloater AutoGammaCC_ScriptedUI) catch()	
	AutoGammaCC_ScriptedUI = newRolloutFloater "AutoGamma Interface" 366 155
	addRollout AutoGammaCC_Controls AutoGammaCC_ScriptedUI
	addRollout AutoGammaCC_OverrideRollout AutoGammaCC_ScriptedUI rolledUp:true


)